<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'AccessControlListEntry' => '\\StructType\\AccessControlListEntry',
            'AccessControlList' => '\\StructType\\AccessControlList',
            'AccessMiscRight' => '\\StructType\\AccessMiscRight',
            'AccessRight' => '\\StructType\\AccessRight',
            'AccessRightChanges' => '\\StructType\\AccessRightChanges',
            'AccessRightEntry' => '\\StructType\\AccessRightEntry',
            'AccessRightList' => '\\StructType\\AccessRightList',
            'Account' => '\\StructType\\Account',
            'AccountFlags' => '\\StructType\\AccountFlags',
            'AddressBook' => '\\StructType\\AddressBook',
            'AddressBookItem' => '\\StructType\\AddressBookItem',
            'AddressBookList' => '\\StructType\\AddressBookList',
            'AdvancedInfo' => '\\StructType\\AdvancedInfo',
            'Alarm' => '\\StructType\\Alarm',
            'Appointment' => '\\StructType\\Appointment',
            'AttachmentID' => '\\StructType\\AttachmentID',
            'AttachmentInfo' => '\\StructType\\AttachmentInfo',
            'AttachmentItemInfo' => '\\StructType\\AttachmentItemInfo',
            'Authentication' => '\\StructType\\Authentication',
            'BoxEntry' => '\\StructType\\BoxEntry',
            'CalendarFolderAttribute' => '\\StructType\\CalendarFolderAttribute',
            'CalendarItem' => '\\StructType\\CalendarItem',
            'CalendarPublish' => '\\StructType\\CalendarPublish',
            'CalHost' => '\\StructType\\CalHost',
            'Category' => '\\StructType\\Category',
            'CategoryFlags' => '\\StructType\\CategoryFlags',
            'CategoryList' => '\\StructType\\CategoryList',
            'CategoryRefList' => '\\StructType\\CategoryRefList',
            'ChecklistInfo' => '\\StructType\\ChecklistInfo',
            'ColumnSettings' => '\\StructType\\ColumnSettings',
            'CommentStatus' => '\\StructType\\CommentStatus',
            'Contact' => '\\StructType\\Contact',
            'ContactFolder' => '\\StructType\\ContactFolder',
            'ContactNote' => '\\StructType\\ContactNote',
            'ContactNotes' => '\\StructType\\ContactNotes',
            'ContactRefList' => '\\StructType\\ContactRefList',
            'ContainerItem' => '\\StructType\\ContainerItem',
            'ContainerRef' => '\\StructType\\ContainerRef',
            'Custom' => '\\StructType\\Custom',
            'CustomList' => '\\StructType\\CustomList',
            'DayOfMonthList' => '\\StructType\\DayOfMonthList',
            'DayOfWeek' => '\\StructType\\DayOfWeek',
            'DayOfYearList' => '\\StructType\\DayOfYearList',
            'DayOfYearWeek' => '\\StructType\\DayOfYearWeek',
            'DayOfYearWeekList' => '\\StructType\\DayOfYearWeekList',
            'DelegatedStatus' => '\\StructType\\DelegatedStatus',
            'DelegateeStatus' => '\\StructType\\DelegateeStatus',
            'DeltaInfo' => '\\StructType\\DeltaInfo',
            'DiskSpaceUsage' => '\\StructType\\DiskSpaceUsage',
            'DisplayFlags' => '\\StructType\\DisplayFlags',
            'DisplaySettings' => '\\StructType\\DisplaySettings',
            'DisplaySettingsList' => '\\StructType\\DisplaySettingsList',
            'Distribution' => '\\StructType\\Distribution',
            'Document' => '\\StructType\\Document',
            'DocumentCustom' => '\\StructType\\DocumentCustom',
            'DocumentRef' => '\\StructType\\DocumentRef',
            'DocumentType' => '\\StructType\\DocumentType',
            'DocumentTypeList' => '\\StructType\\DocumentTypeList',
            'EmailAddressList' => '\\StructType\\EmailAddressList',
            'Filter' => '\\StructType\\Filter',
            'FilterElement' => '\\StructType\\FilterElement',
            'FilterEntry' => '\\StructType\\FilterEntry',
            'FilterGroup' => '\\StructType\\FilterGroup',
            'Folder' => '\\StructType\\Folder',
            'FolderACL' => '\\StructType\\FolderACL',
            'FolderACLEntry' => '\\StructType\\FolderACLEntry',
            'FolderDisplaySettings' => '\\StructType\\FolderDisplaySettings',
            'FolderFlags' => '\\StructType\\FolderFlags',
            'FolderList' => '\\StructType\\FolderList',
            'FreeBusyBlockList' => '\\StructType\\FreeBusyBlockList',
            'FreeBusyBlock' => '\\StructType\\FreeBusyBlock',
            'FreeBusyInfo' => '\\StructType\\FreeBusyInfo',
            'FreeBusyUserList' => '\\StructType\\FreeBusyUserList',
            'FreeBusyInfoList' => '\\StructType\\FreeBusyInfoList',
            'FreeBusyStats' => '\\StructType\\FreeBusyStats',
            'From' => '\\StructType\\From',
            'FullName' => '\\StructType\\FullName',
            'GeneralAccount' => '\\StructType\\GeneralAccount',
            'Group' => '\\StructType\\Group',
            'GroupMember' => '\\StructType\\GroupMember',
            'GroupMemberList' => '\\StructType\\GroupMemberList',
            'Header' => '\\StructType\\Header',
            'Host' => '\\StructType\\Host',
            'IMAP' => '\\StructType\\IMAP',
            'IMAPFolder' => '\\StructType\\IMAPFolder',
            'ImAddress' => '\\StructType\\ImAddress',
            'ImAddressList' => '\\StructType\\ImAddressList',
            'InternetStatusTracking' => '\\StructType\\InternetStatusTracking',
            'Item' => '\\StructType\\Item',
            'ItemChanges' => '\\StructType\\ItemChanges',
            'ItemList' => '\\StructType\\ItemList',
            'ItemOptions' => '\\StructType\\ItemOptions',
            'ItemRef' => '\\StructType\\ItemRef',
            'ItemRefList' => '\\StructType\\ItemRefList',
            'Items' => '\\StructType\\Items',
            'ItemStatus' => '\\StructType\\ItemStatus',
            'ItemThreading' => '\\StructType\\ItemThreading',
            'JunkEntry' => '\\StructType\\JunkEntry',
            'JunkHandlingList' => '\\StructType\\JunkHandlingList',
            'Library' => '\\StructType\\Library',
            'LibraryList' => '\\StructType\\LibraryList',
            'LinkInfo' => '\\StructType\\LinkInfo',
            'LookupTable' => '\\StructType\\LookupTable',
            'Mail' => '\\StructType\\Mail',
            'MessageBody' => '\\StructType\\MessageBody',
            'MessagePart' => '\\StructType\\MessagePart',
            'ModifyItem' => '\\StructType\\ModifyItem',
            'MonthList' => '\\StructType\\MonthList',
            'MoveItem' => '\\StructType\\MoveItem',
            'NameAndEmail' => '\\StructType\\NameAndEmail',
            'Nickname' => '\\StructType\\Nickname',
            'NNTP' => '\\StructType\\NNTP',
            'NNTPFolder' => '\\StructType\\NNTPFolder',
            'NNTPSettings' => '\\StructType\\NNTPSettings',
            'Note' => '\\StructType\\Note',
            'NotifyEntry' => '\\StructType\\NotifyEntry',
            'NotifyEntryChanges' => '\\StructType\\NotifyEntryChanges',
            'NotifyList' => '\\StructType\\NotifyList',
            'OfficeInfo' => '\\StructType\\OfficeInfo',
            'Organization' => '\\StructType\\Organization',
            'Owner' => '\\StructType\\Owner',
            'PanelDisplaySettings' => '\\StructType\\PanelDisplaySettings',
            'PanelList' => '\\StructType\\PanelList',
            'PersonalInfo' => '\\StructType\\PersonalInfo',
            'PhoneFlags' => '\\StructType\\PhoneFlags',
            'PhoneList' => '\\StructType\\PhoneList',
            'PhoneMessage' => '\\StructType\\PhoneMessage',
            'PhoneNumber' => '\\StructType\\PhoneNumber',
            'PictureData' => '\\StructType\\PictureData',
            'PlainText' => '\\StructType\\PlainText',
            'PollField' => '\\StructType\\PollField',
            'PollInfo' => '\\StructType\\PollInfo',
            'PollInfoList' => '\\StructType\\PollInfoList',
            'PollNotify' => '\\StructType\\PollNotify',
            'PollSettings' => '\\StructType\\PollSettings',
            'PostalAddress' => '\\StructType\\PostalAddress',
            'PostalAddressList' => '\\StructType\\PostalAddressList',
            'ProblemEntry' => '\\StructType\\ProblemEntry',
            'ProblemList' => '\\StructType\\ProblemList',
            'Proxy' => '\\StructType\\Proxy',
            'ProxyFolder' => '\\StructType\\ProxyFolder',
            'ProxyUser' => '\\StructType\\ProxyUser',
            'ProxyList' => '\\StructType\\ProxyList',
            'Query' => '\\StructType\\Query',
            'QueryFolder' => '\\StructType\\QueryFolder',
            'QueryTarget' => '\\StructType\\QueryTarget',
            'QueryTargetList' => '\\StructType\\QueryTargetList',
            'RangeDays' => '\\StructType\\RangeDays',
            'Recipient' => '\\StructType\\Recipient',
            'RecipientList' => '\\StructType\\RecipientList',
            'RecipientStatus' => '\\StructType\\RecipientStatus',
            'RecurrenceDateType' => '\\StructType\\RecurrenceDateType',
            'RecurrenceRule' => '\\StructType\\RecurrenceRule',
            'ReferenceInfo' => '\\StructType\\ReferenceInfo',
            'Resource' => '\\StructType\\Resource',
            'ReturnNotification' => '\\StructType\\ReturnNotification',
            'ReturnNotificationOptions' => '\\StructType\\ReturnNotificationOptions',
            'Rights' => '\\StructType\\Rights',
            'Rule' => '\\StructType\\Rule',
            'RuleAction' => '\\StructType\\RuleAction',
            'RuleActionList' => '\\StructType\\RuleActionList',
            'RuleList' => '\\StructType\\RuleList',
            'SendOptionsRequestReply' => '\\StructType\\SendOptionsRequestReply',
            'SendOptions' => '\\StructType\\SendOptions',
            'SendTotals' => '\\StructType\\SendTotals',
            'Server' => '\\StructType\\Server',
            'ServerFlags' => '\\StructType\\ServerFlags',
            'Settings' => '\\StructType\\Settings',
            'SettingsGroup' => '\\StructType\\SettingsGroup',
            'SettingsList' => '\\StructType\\SettingsList',
            'SharedBook' => '\\StructType\\SharedBook',
            'SharedFolder' => '\\StructType\\SharedFolder',
            'SharedFolderNotification' => '\\StructType\\SharedFolderNotification',
            'SharedNotification' => '\\StructType\\SharedNotification',
            'Signature' => '\\StructType\\Signature',
            'Signatures' => '\\StructType\\Signatures',
            'SignatureData' => '\\StructType\\SignatureData',
            'SignatureSettings' => '\\StructType\\SignatureSettings',
            'SMimeOperation' => '\\StructType\\SMimeOperation',
            'Sort' => '\\StructType\\Sort',
            'Status' => '\\StructType\\Status',
            'StatusTracking' => '\\StructType\\StatusTracking',
            'StatusTrackingFlags' => '\\StructType\\StatusTrackingFlags',
            'Subscribe' => '\\StructType\\Subscribe',
            'SystemFolder' => '\\StructType\\SystemFolder',
            'Task' => '\\StructType\\Task',
            'TextLines' => '\\StructType\\TextLines',
            'Timezone' => '\\StructType\\Timezone',
            'TimezoneComponent' => '\\StructType\\TimezoneComponent',
            'TimezoneList' => '\\StructType\\TimezoneList',
            'TrustedApplication' => '\\StructType\\TrustedApplication',
            'UserContactFolder' => '\\StructType\\UserContactFolder',
            'UserInfo' => '\\StructType\\UserInfo',
            'UserList' => '\\StructType\\UserList',
            'Version' => '\\StructType\\Version',
            'VersionEvent' => '\\StructType\\VersionEvent',
            'WebAccessSettings' => '\\StructType\\WebAccessSettings',
            'acceptRequest' => '\\StructType\\AcceptRequest',
            'acceptResponse' => '\\StructType\\AcceptResponse',
            'acceptShareRequest' => '\\StructType\\AcceptShareRequest',
            'acceptShareResponse' => '\\StructType\\AcceptShareResponse',
            'addItemRequest' => '\\StructType\\AddItemRequest',
            'addItemResponse' => '\\StructType\\AddItemResponse',
            'addItemsRequest' => '\\StructType\\AddItemsRequest',
            'addItemsResponse' => '\\StructType\\AddItemsResponse',
            'addMembersRequest' => '\\StructType\\AddMembersRequest',
            'addMembersResponse' => '\\StructType\\AddMembersResponse',
            'archiveRequest' => '\\StructType\\ArchiveRequest',
            'archiveResponse' => '\\StructType\\ArchiveResponse',
            'closeFreeBusySessionRequest' => '\\StructType\\CloseFreeBusySessionRequest',
            'closeFreeBusySessionResponse' => '\\StructType\\CloseFreeBusySessionResponse',
            'completeRequest' => '\\StructType\\CompleteRequest',
            'completeResponse' => '\\StructType\\CompleteResponse',
            'createCursorRequest' => '\\StructType\\CreateCursorRequest',
            'createCursorResponse' => '\\StructType\\CreateCursorResponse',
            'createItemRequest' => '\\StructType\\CreateItemRequest',
            'createItemResponse' => '\\StructType\\CreateItemResponse',
            'createItemsRequest' => '\\StructType\\CreateItemsRequest',
            'createItemsResponse' => '\\StructType\\CreateItemsResponse',
            'createJunkEntryRequest' => '\\StructType\\CreateJunkEntryRequest',
            'createJunkEntryResponse' => '\\StructType\\CreateJunkEntryResponse',
            'createNotifyRequest' => '\\StructType\\CreateNotifyRequest',
            'createNotifyResponse' => '\\StructType\\CreateNotifyResponse',
            'createProxyAccessRequest' => '\\StructType\\CreateProxyAccessRequest',
            'createProxyAccessResponse' => '\\StructType\\CreateProxyAccessResponse',
            'createSignatureRequest' => '\\StructType\\CreateSignatureRequest',
            'createSignatureResponse' => '\\StructType\\CreateSignatureResponse',
            'declineRequest' => '\\StructType\\DeclineRequest',
            'declineResponse' => '\\StructType\\DeclineResponse',
            'delegateRequest' => '\\StructType\\DelegateRequest',
            'delegateResponse' => '\\StructType\\DelegateResponse',
            'destroyCursorRequest' => '\\StructType\\DestroyCursorRequest',
            'destroyCursorResponse' => '\\StructType\\DestroyCursorResponse',
            'executeRuleRequest' => '\\StructType\\ExecuteRuleRequest',
            'executeRuleResponse' => '\\StructType\\ExecuteRuleResponse',
            'forwardRequest' => '\\StructType\\ForwardRequest',
            'forwardResponse' => '\\StructType\\ForwardResponse',
            'getAccountListRequest' => '\\StructType\\GetAccountListRequest',
            'getAccountListResponse' => '\\StructType\\GetAccountListResponse',
            'getAddressBookListRequest' => '\\StructType\\GetAddressBookListRequest',
            'getAddressBookListResponse' => '\\StructType\\GetAddressBookListResponse',
            'getArchiveItemsRequest' => '\\StructType\\GetArchiveItemsRequest',
            'getArchiveItemsResponse' => '\\StructType\\GetArchiveItemsResponse',
            'getAttachmentRequest' => '\\StructType\\GetAttachmentRequest',
            'getAttachmentResponse' => '\\StructType\\GetAttachmentResponse',
            'getCategoryListRequest' => '\\StructType\\GetCategoryListRequest',
            'getCategoryListResponse' => '\\StructType\\GetCategoryListResponse',
            'getContactHistoryFilterRequest' => '\\StructType\\GetContactHistoryFilterRequest',
            'getContactHistoryFilterResponse' => '\\StructType\\GetContactHistoryFilterResponse',
            'getCustomListRequest' => '\\StructType\\GetCustomListRequest',
            'getCustomListResponse' => '\\StructType\\GetCustomListResponse',
            'getDeltasRequest' => '\\StructType\\GetDeltasRequest',
            'getDeltasResponse' => '\\StructType\\GetDeltasResponse',
            'getDeltaInfoRequest' => '\\StructType\\GetDeltaInfoRequest',
            'getDeltaInfoResponse' => '\\StructType\\GetDeltaInfoResponse',
            'getDiskSpaceUsageRequest' => '\\StructType\\GetDiskSpaceUsageRequest',
            'getDiskSpaceUsageResponse' => '\\StructType\\GetDiskSpaceUsageResponse',
            'getDocumentTypeListRequest' => '\\StructType\\GetDocumentTypeListRequest',
            'getDocumentTypeListResponse' => '\\StructType\\GetDocumentTypeListResponse',
            'getFolderRequest' => '\\StructType\\GetFolderRequest',
            'getFolderResponse' => '\\StructType\\GetFolderResponse',
            'getFolderListRequest' => '\\StructType\\GetFolderListRequest',
            'getFolderListResponse' => '\\StructType\\GetFolderListResponse',
            'getFreeBusyRequest' => '\\StructType\\GetFreeBusyRequest',
            'getFreeBusyResponse' => '\\StructType\\GetFreeBusyResponse',
            'getItemRequest' => '\\StructType\\GetItemRequest',
            'getItemResponse' => '\\StructType\\GetItemResponse',
            'getItemsRequest' => '\\StructType\\GetItemsRequest',
            'getItemsResponse' => '\\StructType\\GetItemsResponse',
            'getJunkEntriesRequest' => '\\StructType\\GetJunkEntriesRequest',
            'getJunkEntriesResponse' => '\\StructType\\GetJunkEntriesResponse',
            'getJunkMailSettingsRequest' => '\\StructType\\GetJunkMailSettingsRequest',
            'getJunkMailSettingsResponse' => '\\StructType\\GetJunkMailSettingsResponse',
            'getLibraryItemRequest' => '\\StructType\\GetLibraryItemRequest',
            'getLibraryItemResponse' => '\\StructType\\GetLibraryItemResponse',
            'getLibraryListRequest' => '\\StructType\\GetLibraryListRequest',
            'getLibraryListResponse' => '\\StructType\\GetLibraryListResponse',
            'getMemberOfRequest' => '\\StructType\\GetMemberOfRequest',
            'getMemberOfResponse' => '\\StructType\\GetMemberOfResponse',
            'getNotifyListRequest' => '\\StructType\\GetNotifyListRequest',
            'getNotifyListResponse' => '\\StructType\\GetNotifyListResponse',
            'getQuickMessagesRequest' => '\\StructType\\GetQuickMessagesRequest',
            'getQuickMessagesResponse' => '\\StructType\\GetQuickMessagesResponse',
            'getProxyAccessListRequest' => '\\StructType\\GetProxyAccessListRequest',
            'getProxyAccessListResponse' => '\\StructType\\GetProxyAccessListResponse',
            'getProxyListRequest' => '\\StructType\\GetProxyListRequest',
            'getProxyListResponse' => '\\StructType\\GetProxyListResponse',
            'getRuleListRequest' => '\\StructType\\GetRuleListRequest',
            'getRuleListResponse' => '\\StructType\\GetRuleListResponse',
            'getSettingsRequest' => '\\StructType\\GetSettingsRequest',
            'getSettingsResponse' => '\\StructType\\GetSettingsResponse',
            'getSignaturesRequest' => '\\StructType\\GetSignaturesRequest',
            'getSignaturesResponse' => '\\StructType\\GetSignaturesResponse',
            'getStringRequest' => '\\StructType\\GetStringRequest',
            'getStringResponse' => '\\StructType\\GetStringResponse',
            'getTimestampRequest' => '\\StructType\\GetTimestampRequest',
            'getTimestampResponse' => '\\StructType\\GetTimestampResponse',
            'getTimezoneListRequest' => '\\StructType\\GetTimezoneListRequest',
            'getTimezoneListResponse' => '\\StructType\\GetTimezoneListResponse',
            'getUnreadRequest' => '\\StructType\\GetUnreadRequest',
            'getUnreadResponse' => '\\StructType\\GetUnreadResponse',
            'getUserListRequest' => '\\StructType\\GetUserListRequest',
            'getUserListResponse' => '\\StructType\\GetUserListResponse',
            'loginRequest' => '\\StructType\\LoginRequest',
            'loginResponse' => '\\StructType\\LoginResponse',
            'logoutRequest' => '\\StructType\\LogoutRequest',
            'logoutResponse' => '\\StructType\\LogoutResponse',
            'markPrivateRequest' => '\\StructType\\MarkPrivateRequest',
            'markPrivateResponse' => '\\StructType\\MarkPrivateResponse',
            'markReadRequest' => '\\StructType\\MarkReadRequest',
            'markReadResponse' => '\\StructType\\MarkReadResponse',
            'markUnPrivateRequest' => '\\StructType\\MarkUnPrivateRequest',
            'markUnPrivateResponse' => '\\StructType\\MarkUnPrivateResponse',
            'markUnReadRequest' => '\\StructType\\MarkUnReadRequest',
            'markUnReadResponse' => '\\StructType\\MarkUnReadResponse',
            'modifyItemRequest' => '\\StructType\\ModifyItemRequest',
            'modifyItemResponse' => '\\StructType\\ModifyItemResponse',
            'modifyItemsRequest' => '\\StructType\\ModifyItemsRequest',
            'modifyItemsResponse' => '\\StructType\\ModifyItemsResponse',
            'modifyJunkEntryRequest' => '\\StructType\\ModifyJunkEntryRequest',
            'modifyJunkEntryResponse' => '\\StructType\\ModifyJunkEntryResponse',
            'modifyJunkMailSettingsRequest' => '\\StructType\\ModifyJunkMailSettingsRequest',
            'modifyJunkMailSettingsResponse' => '\\StructType\\ModifyJunkMailSettingsResponse',
            'modifyNotifyRequest' => '\\StructType\\ModifyNotifyRequest',
            'modifyNotifyResponse' => '\\StructType\\ModifyNotifyResponse',
            'modifyPasswordRequest' => '\\StructType\\ModifyPasswordRequest',
            'modifyPasswordResponse' => '\\StructType\\ModifyPasswordResponse',
            'modifyProxyAccessRequest' => '\\StructType\\ModifyProxyAccessRequest',
            'modifyProxyAccessResponse' => '\\StructType\\ModifyProxyAccessResponse',
            'modifySettingsRequest' => '\\StructType\\ModifySettingsRequest',
            'modifySettingsResponse' => '\\StructType\\ModifySettingsResponse',
            'modifySignaturesRequest' => '\\StructType\\ModifySignaturesRequest',
            'modifySignaturesResponse' => '\\StructType\\ModifySignaturesResponse',
            'moveItemRequest' => '\\StructType\\MoveItemRequest',
            'moveItemResponse' => '\\StructType\\MoveItemResponse',
            'moveItemsRequest' => '\\StructType\\MoveItemsRequest',
            'moveItemsResponse' => '\\StructType\\MoveItemsResponse',
            'pollRequest' => '\\StructType\\PollRequest',
            'pollResponse' => '\\StructType\\PollResponse',
            'positionCursorRequest' => '\\StructType\\PositionCursorRequest',
            'positionCursorResponse' => '\\StructType\\PositionCursorResponse',
            'purgeDeletedItemsRequest' => '\\StructType\\PurgeDeletedItemsRequest',
            'purgeDeletedItemsResponse' => '\\StructType\\PurgeDeletedItemsResponse',
            'purgeRequest' => '\\StructType\\PurgeRequest',
            'purgeResponse' => '\\StructType\\PurgeResponse',
            'readCursorRequest' => '\\StructType\\ReadCursorRequest',
            'readCursorResponse' => '\\StructType\\ReadCursorResponse',
            'removeCustomDefinitionRequest' => '\\StructType\\RemoveCustomDefinitionRequest',
            'removeCustomDefinitionResponse' => '\\StructType\\RemoveCustomDefinitionResponse',
            'removeItemRequest' => '\\StructType\\RemoveItemRequest',
            'removeItemResponse' => '\\StructType\\RemoveItemResponse',
            'removeItemsRequest' => '\\StructType\\RemoveItemsRequest',
            'removeItemsResponse' => '\\StructType\\RemoveItemsResponse',
            'removeJunkEntryRequest' => '\\StructType\\RemoveJunkEntryRequest',
            'removeJunkEntryResponse' => '\\StructType\\RemoveJunkEntryResponse',
            'removeMembersRequest' => '\\StructType\\RemoveMembersRequest',
            'removeMembersResponse' => '\\StructType\\RemoveMembersResponse',
            'removeNotifyRequest' => '\\StructType\\RemoveNotifyRequest',
            'removeNotifyResponse' => '\\StructType\\RemoveNotifyResponse',
            'removeProxyAccessRequest' => '\\StructType\\RemoveProxyAccessRequest',
            'removeProxyAccessResponse' => '\\StructType\\RemoveProxyAccessResponse',
            'removeProxyUserRequest' => '\\StructType\\RemoveProxyUserRequest',
            'removeProxyUserResponse' => '\\StructType\\RemoveProxyUserResponse',
            'removeSignatureRequest' => '\\StructType\\RemoveSignatureRequest',
            'removeSignatureResponse' => '\\StructType\\RemoveSignatureResponse',
            'replyRequest' => '\\StructType\\ReplyRequest',
            'replyResponse' => '\\StructType\\ReplyResponse',
            'resendRequest' => '\\StructType\\ResendRequest',
            'resendResponse' => '\\StructType\\ResendResponse',
            'resolveRequest' => '\\StructType\\ResolveRequest',
            'resolveResponse' => '\\StructType\\ResolveResponse',
            'restoreItemRequest' => '\\StructType\\RestoreItemRequest',
            'restoreItemResponse' => '\\StructType\\RestoreItemResponse',
            'retractRequest' => '\\StructType\\RetractRequest',
            'retractResponse' => '\\StructType\\RetractResponse',
            'sendItemRequest' => '\\StructType\\SendItemRequest',
            'sendItemResponse' => '\\StructType\\SendItemResponse',
            'setTimestampRequest' => '\\StructType\\SetTimestampRequest',
            'setTimestampResponse' => '\\StructType\\SetTimestampResponse',
            'startFreeBusySessionRequest' => '\\StructType\\StartFreeBusySessionRequest',
            'startFreeBusySessionResponse' => '\\StructType\\StartFreeBusySessionResponse',
            'streamedSearchRequest' => '\\StructType\\StreamedSearchRequest',
            'streamedSearchResponse' => '\\StructType\\StreamedSearchResponse',
            'stubItemRequest' => '\\StructType\\StubItemRequest',
            'stubItemResponse' => '\\StructType\\StubItemResponse',
            'unacceptRequest' => '\\StructType\\UnacceptRequest',
            'unacceptResponse' => '\\StructType\\UnacceptResponse',
            'unarchiveRequest' => '\\StructType\\UnarchiveRequest',
            'unarchiveResponse' => '\\StructType\\UnarchiveResponse',
            'uncompleteRequest' => '\\StructType\\UncompleteRequest',
            'uncompleteResponse' => '\\StructType\\UncompleteResponse',
            'updateVersionStatusRequest' => '\\StructType\\UpdateVersionStatusRequest',
            'updateVersionStatusResponse' => '\\StructType\\UpdateVersionStatusResponse',
            'ContainerList' => '\\StructType\\ContainerList',
            'Event' => '\\StructType\\Event',
            'EventDefinition' => '\\StructType\\EventDefinition',
            'EventList' => '\\StructType\\EventList',
            'Events' => '\\StructType\\Events',
            'EventsList' => '\\StructType\\EventsList',
            'EventTypeList' => '\\StructType\\EventTypeList',
            'Notify' => '\\StructType\\Notify',
            'cleanEventConfigurationRequest' => '\\StructType\\CleanEventConfigurationRequest',
            'cleanEventConfigurationResponse' => '\\StructType\\CleanEventConfigurationResponse',
            'configureEventsRequest' => '\\StructType\\ConfigureEventsRequest',
            'configureEventsResponse' => '\\StructType\\ConfigureEventsResponse',
            'getEventConfigurationRequest' => '\\StructType\\GetEventConfigurationRequest',
            'getEventConfigurationResponse' => '\\StructType\\GetEventConfigurationResponse',
            'getEventsRequest' => '\\StructType\\GetEventsRequest',
            'getEventsResponse' => '\\StructType\\GetEventsResponse',
            'removeEventConfigurationRequest' => '\\StructType\\RemoveEventConfigurationRequest',
            'removeEventConfigurationResponse' => '\\StructType\\RemoveEventConfigurationResponse',
            'removeEventsRequest' => '\\StructType\\RemoveEventsRequest',
            'removeEventsResponse' => '\\StructType\\RemoveEventsResponse',
        );
    }
}
