<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AccessControlListEntry StructType
 * @subpackage Structs
 */
class AccessControlListEntry extends NameAndEmail
{
    /**
     * The rights
     * Meta informations extracted from the WSDL
     * - ref: tns:rights
     * @var \StructType\Rights
     */
    public $rights;
    /**
     * Constructor method for AccessControlListEntry
     * @uses AccessControlListEntry::setRights()
     * @param \StructType\Rights $rights
     */
    public function __construct(\StructType\Rights $rights = null)
    {
        $this
            ->setRights($rights);
    }
    /**
     * Get rights value
     * @return \StructType\Rights|null
     */
    public function getRights()
    {
        return $this->rights;
    }
    /**
     * Set rights value
     * @param \StructType\Rights $rights
     * @return \StructType\AccessControlListEntry
     */
    public function setRights(\StructType\Rights $rights = null)
    {
        $this->rights = $rights;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AccessControlListEntry
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
