<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AccountFlags StructType
 * @subpackage Structs
 */
class AccountFlags extends AbstractStructBase
{
    /**
     * The addSignature
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $addSignature;
    /**
     * The addVCard
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $addVCard;
    /**
     * The deleteFromTrash
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $deleteFromTrash;
    /**
     * The downloadExternalBodies
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $downloadExternalBodies;
    /**
     * The downloadHeadersOnly
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $downloadHeadersOnly;
    /**
     * The downloadNewOnly
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $downloadNewOnly;
    /**
     * The expandThreads
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $expandThreads;
    /**
     * The lifeDelete
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $lifeDelete;
    /**
     * The memberOfFullSync
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $memberOfFullSync;
    /**
     * The neverDownloadOldMessages
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $neverDownloadOldMessages;
    /**
     * The pollAtStartup
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $pollAtStartup;
    /**
     * The showSubscribedFolders
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $showSubscribedFolders;
    /**
     * The syncWhenFolderIsSelected
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $syncWhenFolderIsSelected;
    /**
     * The watchMyThreads
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $watchMyThreads;
    /**
     * Constructor method for AccountFlags
     * @uses AccountFlags::setAddSignature()
     * @uses AccountFlags::setAddVCard()
     * @uses AccountFlags::setDeleteFromTrash()
     * @uses AccountFlags::setDownloadExternalBodies()
     * @uses AccountFlags::setDownloadHeadersOnly()
     * @uses AccountFlags::setDownloadNewOnly()
     * @uses AccountFlags::setExpandThreads()
     * @uses AccountFlags::setLifeDelete()
     * @uses AccountFlags::setMemberOfFullSync()
     * @uses AccountFlags::setNeverDownloadOldMessages()
     * @uses AccountFlags::setPollAtStartup()
     * @uses AccountFlags::setShowSubscribedFolders()
     * @uses AccountFlags::setSyncWhenFolderIsSelected()
     * @uses AccountFlags::setWatchMyThreads()
     * @param bool $addSignature
     * @param bool $addVCard
     * @param bool $deleteFromTrash
     * @param bool $downloadExternalBodies
     * @param bool $downloadHeadersOnly
     * @param bool $downloadNewOnly
     * @param bool $expandThreads
     * @param bool $lifeDelete
     * @param bool $memberOfFullSync
     * @param bool $neverDownloadOldMessages
     * @param bool $pollAtStartup
     * @param bool $showSubscribedFolders
     * @param bool $syncWhenFolderIsSelected
     * @param bool $watchMyThreads
     */
    public function __construct($addSignature = null, $addVCard = null, $deleteFromTrash = null, $downloadExternalBodies = null, $downloadHeadersOnly = null, $downloadNewOnly = null, $expandThreads = null, $lifeDelete = null, $memberOfFullSync = null, $neverDownloadOldMessages = null, $pollAtStartup = null, $showSubscribedFolders = null, $syncWhenFolderIsSelected = null, $watchMyThreads = null)
    {
        $this
            ->setAddSignature($addSignature)
            ->setAddVCard($addVCard)
            ->setDeleteFromTrash($deleteFromTrash)
            ->setDownloadExternalBodies($downloadExternalBodies)
            ->setDownloadHeadersOnly($downloadHeadersOnly)
            ->setDownloadNewOnly($downloadNewOnly)
            ->setExpandThreads($expandThreads)
            ->setLifeDelete($lifeDelete)
            ->setMemberOfFullSync($memberOfFullSync)
            ->setNeverDownloadOldMessages($neverDownloadOldMessages)
            ->setPollAtStartup($pollAtStartup)
            ->setShowSubscribedFolders($showSubscribedFolders)
            ->setSyncWhenFolderIsSelected($syncWhenFolderIsSelected)
            ->setWatchMyThreads($watchMyThreads);
    }
    /**
     * Get addSignature value
     * @return bool|null
     */
    public function getAddSignature()
    {
        return $this->addSignature;
    }
    /**
     * Set addSignature value
     * @param bool $addSignature
     * @return \StructType\AccountFlags
     */
    public function setAddSignature($addSignature = null)
    {
        // validation for constraint: boolean
        if (!is_null($addSignature) && !is_bool($addSignature)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($addSignature)), __LINE__);
        }
        $this->addSignature = $addSignature;
        return $this;
    }
    /**
     * Get addVCard value
     * @return bool|null
     */
    public function getAddVCard()
    {
        return $this->addVCard;
    }
    /**
     * Set addVCard value
     * @param bool $addVCard
     * @return \StructType\AccountFlags
     */
    public function setAddVCard($addVCard = null)
    {
        // validation for constraint: boolean
        if (!is_null($addVCard) && !is_bool($addVCard)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($addVCard)), __LINE__);
        }
        $this->addVCard = $addVCard;
        return $this;
    }
    /**
     * Get deleteFromTrash value
     * @return bool|null
     */
    public function getDeleteFromTrash()
    {
        return $this->deleteFromTrash;
    }
    /**
     * Set deleteFromTrash value
     * @param bool $deleteFromTrash
     * @return \StructType\AccountFlags
     */
    public function setDeleteFromTrash($deleteFromTrash = null)
    {
        // validation for constraint: boolean
        if (!is_null($deleteFromTrash) && !is_bool($deleteFromTrash)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($deleteFromTrash)), __LINE__);
        }
        $this->deleteFromTrash = $deleteFromTrash;
        return $this;
    }
    /**
     * Get downloadExternalBodies value
     * @return bool|null
     */
    public function getDownloadExternalBodies()
    {
        return $this->downloadExternalBodies;
    }
    /**
     * Set downloadExternalBodies value
     * @param bool $downloadExternalBodies
     * @return \StructType\AccountFlags
     */
    public function setDownloadExternalBodies($downloadExternalBodies = null)
    {
        // validation for constraint: boolean
        if (!is_null($downloadExternalBodies) && !is_bool($downloadExternalBodies)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($downloadExternalBodies)), __LINE__);
        }
        $this->downloadExternalBodies = $downloadExternalBodies;
        return $this;
    }
    /**
     * Get downloadHeadersOnly value
     * @return bool|null
     */
    public function getDownloadHeadersOnly()
    {
        return $this->downloadHeadersOnly;
    }
    /**
     * Set downloadHeadersOnly value
     * @param bool $downloadHeadersOnly
     * @return \StructType\AccountFlags
     */
    public function setDownloadHeadersOnly($downloadHeadersOnly = null)
    {
        // validation for constraint: boolean
        if (!is_null($downloadHeadersOnly) && !is_bool($downloadHeadersOnly)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($downloadHeadersOnly)), __LINE__);
        }
        $this->downloadHeadersOnly = $downloadHeadersOnly;
        return $this;
    }
    /**
     * Get downloadNewOnly value
     * @return bool|null
     */
    public function getDownloadNewOnly()
    {
        return $this->downloadNewOnly;
    }
    /**
     * Set downloadNewOnly value
     * @param bool $downloadNewOnly
     * @return \StructType\AccountFlags
     */
    public function setDownloadNewOnly($downloadNewOnly = null)
    {
        // validation for constraint: boolean
        if (!is_null($downloadNewOnly) && !is_bool($downloadNewOnly)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($downloadNewOnly)), __LINE__);
        }
        $this->downloadNewOnly = $downloadNewOnly;
        return $this;
    }
    /**
     * Get expandThreads value
     * @return bool|null
     */
    public function getExpandThreads()
    {
        return $this->expandThreads;
    }
    /**
     * Set expandThreads value
     * @param bool $expandThreads
     * @return \StructType\AccountFlags
     */
    public function setExpandThreads($expandThreads = null)
    {
        // validation for constraint: boolean
        if (!is_null($expandThreads) && !is_bool($expandThreads)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($expandThreads)), __LINE__);
        }
        $this->expandThreads = $expandThreads;
        return $this;
    }
    /**
     * Get lifeDelete value
     * @return bool|null
     */
    public function getLifeDelete()
    {
        return $this->lifeDelete;
    }
    /**
     * Set lifeDelete value
     * @param bool $lifeDelete
     * @return \StructType\AccountFlags
     */
    public function setLifeDelete($lifeDelete = null)
    {
        // validation for constraint: boolean
        if (!is_null($lifeDelete) && !is_bool($lifeDelete)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($lifeDelete)), __LINE__);
        }
        $this->lifeDelete = $lifeDelete;
        return $this;
    }
    /**
     * Get memberOfFullSync value
     * @return bool|null
     */
    public function getMemberOfFullSync()
    {
        return $this->memberOfFullSync;
    }
    /**
     * Set memberOfFullSync value
     * @param bool $memberOfFullSync
     * @return \StructType\AccountFlags
     */
    public function setMemberOfFullSync($memberOfFullSync = null)
    {
        // validation for constraint: boolean
        if (!is_null($memberOfFullSync) && !is_bool($memberOfFullSync)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($memberOfFullSync)), __LINE__);
        }
        $this->memberOfFullSync = $memberOfFullSync;
        return $this;
    }
    /**
     * Get neverDownloadOldMessages value
     * @return bool|null
     */
    public function getNeverDownloadOldMessages()
    {
        return $this->neverDownloadOldMessages;
    }
    /**
     * Set neverDownloadOldMessages value
     * @param bool $neverDownloadOldMessages
     * @return \StructType\AccountFlags
     */
    public function setNeverDownloadOldMessages($neverDownloadOldMessages = null)
    {
        // validation for constraint: boolean
        if (!is_null($neverDownloadOldMessages) && !is_bool($neverDownloadOldMessages)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($neverDownloadOldMessages)), __LINE__);
        }
        $this->neverDownloadOldMessages = $neverDownloadOldMessages;
        return $this;
    }
    /**
     * Get pollAtStartup value
     * @return bool|null
     */
    public function getPollAtStartup()
    {
        return $this->pollAtStartup;
    }
    /**
     * Set pollAtStartup value
     * @param bool $pollAtStartup
     * @return \StructType\AccountFlags
     */
    public function setPollAtStartup($pollAtStartup = null)
    {
        // validation for constraint: boolean
        if (!is_null($pollAtStartup) && !is_bool($pollAtStartup)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($pollAtStartup)), __LINE__);
        }
        $this->pollAtStartup = $pollAtStartup;
        return $this;
    }
    /**
     * Get showSubscribedFolders value
     * @return bool|null
     */
    public function getShowSubscribedFolders()
    {
        return $this->showSubscribedFolders;
    }
    /**
     * Set showSubscribedFolders value
     * @param bool $showSubscribedFolders
     * @return \StructType\AccountFlags
     */
    public function setShowSubscribedFolders($showSubscribedFolders = null)
    {
        // validation for constraint: boolean
        if (!is_null($showSubscribedFolders) && !is_bool($showSubscribedFolders)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($showSubscribedFolders)), __LINE__);
        }
        $this->showSubscribedFolders = $showSubscribedFolders;
        return $this;
    }
    /**
     * Get syncWhenFolderIsSelected value
     * @return bool|null
     */
    public function getSyncWhenFolderIsSelected()
    {
        return $this->syncWhenFolderIsSelected;
    }
    /**
     * Set syncWhenFolderIsSelected value
     * @param bool $syncWhenFolderIsSelected
     * @return \StructType\AccountFlags
     */
    public function setSyncWhenFolderIsSelected($syncWhenFolderIsSelected = null)
    {
        // validation for constraint: boolean
        if (!is_null($syncWhenFolderIsSelected) && !is_bool($syncWhenFolderIsSelected)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($syncWhenFolderIsSelected)), __LINE__);
        }
        $this->syncWhenFolderIsSelected = $syncWhenFolderIsSelected;
        return $this;
    }
    /**
     * Get watchMyThreads value
     * @return bool|null
     */
    public function getWatchMyThreads()
    {
        return $this->watchMyThreads;
    }
    /**
     * Set watchMyThreads value
     * @param bool $watchMyThreads
     * @return \StructType\AccountFlags
     */
    public function setWatchMyThreads($watchMyThreads = null)
    {
        // validation for constraint: boolean
        if (!is_null($watchMyThreads) && !is_bool($watchMyThreads)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($watchMyThreads)), __LINE__);
        }
        $this->watchMyThreads = $watchMyThreads;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AccountFlags
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
