<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ContactNotes StructType
 * @subpackage Structs
 */
class ContactNotes extends AbstractStructBase
{
    /**
     * The contactNote
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ContactNote[]
     */
    public $contactNote;
    /**
     * Constructor method for ContactNotes
     * @uses ContactNotes::setContactNote()
     * @param \StructType\ContactNote[] $contactNote
     */
    public function __construct(array $contactNote = array())
    {
        $this
            ->setContactNote($contactNote);
    }
    /**
     * Get contactNote value
     * @return \StructType\ContactNote[]|null
     */
    public function getContactNote()
    {
        return $this->contactNote;
    }
    /**
     * Set contactNote value
     * @throws \InvalidArgumentException
     * @param \StructType\ContactNote[] $contactNote
     * @return \StructType\ContactNotes
     */
    public function setContactNote(array $contactNote = array())
    {
        foreach ($contactNote as $contactNotesContactNoteItem) {
            // validation for constraint: itemType
            if (!$contactNotesContactNoteItem instanceof \StructType\ContactNote) {
                throw new \InvalidArgumentException(sprintf('The contactNote property can only contain items of \StructType\ContactNote, "%s" given', is_object($contactNotesContactNoteItem) ? get_class($contactNotesContactNoteItem) : gettype($contactNotesContactNoteItem)), __LINE__);
            }
        }
        $this->contactNote = $contactNote;
        return $this;
    }
    /**
     * Add item to contactNote value
     * @throws \InvalidArgumentException
     * @param \StructType\ContactNote $item
     * @return \StructType\ContactNotes
     */
    public function addToContactNote(\StructType\ContactNote $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ContactNote) {
            throw new \InvalidArgumentException(sprintf('The contactNote property can only contain items of \StructType\ContactNote, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->contactNote[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ContactNotes
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
