<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for createSignatureRequest StructType
 * @subpackage Structs
 */
class CreateSignatureRequest extends AbstractStructBase
{
    /**
     * The signature
     * @var \StructType\Signature
     */
    public $signature;
    /**
     * Constructor method for createSignatureRequest
     * @uses CreateSignatureRequest::setSignature()
     * @param \StructType\Signature $signature
     */
    public function __construct(\StructType\Signature $signature = null)
    {
        $this
            ->setSignature($signature);
    }
    /**
     * Get signature value
     * @return \StructType\Signature|null
     */
    public function getSignature()
    {
        return $this->signature;
    }
    /**
     * Set signature value
     * @param \StructType\Signature $signature
     * @return \StructType\CreateSignatureRequest
     */
    public function setSignature(\StructType\Signature $signature = null)
    {
        $this->signature = $signature;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreateSignatureRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
