<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DayOfYearWeekList StructType
 * @subpackage Structs
 */
class DayOfYearWeekList extends AbstractStructBase
{
    /**
     * The day
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\DayOfYearWeek[]
     */
    public $day;
    /**
     * Constructor method for DayOfYearWeekList
     * @uses DayOfYearWeekList::setDay()
     * @param \StructType\DayOfYearWeek[] $day
     */
    public function __construct(array $day = array())
    {
        $this
            ->setDay($day);
    }
    /**
     * Get day value
     * @return \StructType\DayOfYearWeek[]|null
     */
    public function getDay()
    {
        return $this->day;
    }
    /**
     * Set day value
     * @throws \InvalidArgumentException
     * @param \StructType\DayOfYearWeek[] $day
     * @return \StructType\DayOfYearWeekList
     */
    public function setDay(array $day = array())
    {
        foreach ($day as $dayOfYearWeekListDayItem) {
            // validation for constraint: itemType
            if (!$dayOfYearWeekListDayItem instanceof \StructType\DayOfYearWeek) {
                throw new \InvalidArgumentException(sprintf('The day property can only contain items of \StructType\DayOfYearWeek, "%s" given', is_object($dayOfYearWeekListDayItem) ? get_class($dayOfYearWeekListDayItem) : gettype($dayOfYearWeekListDayItem)), __LINE__);
            }
        }
        $this->day = $day;
        return $this;
    }
    /**
     * Add item to day value
     * @throws \InvalidArgumentException
     * @param \StructType\DayOfYearWeek $item
     * @return \StructType\DayOfYearWeekList
     */
    public function addToDay(\StructType\DayOfYearWeek $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DayOfYearWeek) {
            throw new \InvalidArgumentException(sprintf('The day property can only contain items of \StructType\DayOfYearWeek, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->day[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DayOfYearWeekList
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
