<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DisplayFlags StructType
 * @subpackage Structs
 */
class DisplayFlags extends AbstractStructBase
{
    /**
     * The hideNonTasklistItems
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $hideNonTasklistItems;
    /**
     * The showQuickViewer
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $showQuickViewer;
    /**
     * The rememberQuickViewer
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $rememberQuickViewer;
    /**
     * The summary
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $summary;
    /**
     * The showGroupLabels
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $showGroupLabels;
    /**
     * The showFolderTree
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $showFolderTree;
    /**
     * The rememberFolderTree
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $rememberFolderTree;
    /**
     * The showSimpleFolderTree
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $showSimpleFolderTree;
    /**
     * The showFullFolderTree
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $showFullFolderTree;
    /**
     * The messagePreview
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $messagePreview;
    /**
     * The hideCompleted
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $hideCompleted;
    /**
     * The hideCompletedAfterOneDay
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $hideCompletedAfterOneDay;
    /**
     * Constructor method for DisplayFlags
     * @uses DisplayFlags::setHideNonTasklistItems()
     * @uses DisplayFlags::setShowQuickViewer()
     * @uses DisplayFlags::setRememberQuickViewer()
     * @uses DisplayFlags::setSummary()
     * @uses DisplayFlags::setShowGroupLabels()
     * @uses DisplayFlags::setShowFolderTree()
     * @uses DisplayFlags::setRememberFolderTree()
     * @uses DisplayFlags::setShowSimpleFolderTree()
     * @uses DisplayFlags::setShowFullFolderTree()
     * @uses DisplayFlags::setMessagePreview()
     * @uses DisplayFlags::setHideCompleted()
     * @uses DisplayFlags::setHideCompletedAfterOneDay()
     * @param bool $hideNonTasklistItems
     * @param bool $showQuickViewer
     * @param bool $rememberQuickViewer
     * @param bool $summary
     * @param bool $showGroupLabels
     * @param bool $showFolderTree
     * @param bool $rememberFolderTree
     * @param bool $showSimpleFolderTree
     * @param bool $showFullFolderTree
     * @param bool $messagePreview
     * @param bool $hideCompleted
     * @param bool $hideCompletedAfterOneDay
     */
    public function __construct($hideNonTasklistItems = null, $showQuickViewer = null, $rememberQuickViewer = null, $summary = null, $showGroupLabels = null, $showFolderTree = null, $rememberFolderTree = null, $showSimpleFolderTree = null, $showFullFolderTree = null, $messagePreview = null, $hideCompleted = null, $hideCompletedAfterOneDay = null)
    {
        $this
            ->setHideNonTasklistItems($hideNonTasklistItems)
            ->setShowQuickViewer($showQuickViewer)
            ->setRememberQuickViewer($rememberQuickViewer)
            ->setSummary($summary)
            ->setShowGroupLabels($showGroupLabels)
            ->setShowFolderTree($showFolderTree)
            ->setRememberFolderTree($rememberFolderTree)
            ->setShowSimpleFolderTree($showSimpleFolderTree)
            ->setShowFullFolderTree($showFullFolderTree)
            ->setMessagePreview($messagePreview)
            ->setHideCompleted($hideCompleted)
            ->setHideCompletedAfterOneDay($hideCompletedAfterOneDay);
    }
    /**
     * Get hideNonTasklistItems value
     * @return bool|null
     */
    public function getHideNonTasklistItems()
    {
        return $this->hideNonTasklistItems;
    }
    /**
     * Set hideNonTasklistItems value
     * @param bool $hideNonTasklistItems
     * @return \StructType\DisplayFlags
     */
    public function setHideNonTasklistItems($hideNonTasklistItems = null)
    {
        // validation for constraint: boolean
        if (!is_null($hideNonTasklistItems) && !is_bool($hideNonTasklistItems)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($hideNonTasklistItems)), __LINE__);
        }
        $this->hideNonTasklistItems = $hideNonTasklistItems;
        return $this;
    }
    /**
     * Get showQuickViewer value
     * @return bool|null
     */
    public function getShowQuickViewer()
    {
        return $this->showQuickViewer;
    }
    /**
     * Set showQuickViewer value
     * @param bool $showQuickViewer
     * @return \StructType\DisplayFlags
     */
    public function setShowQuickViewer($showQuickViewer = null)
    {
        // validation for constraint: boolean
        if (!is_null($showQuickViewer) && !is_bool($showQuickViewer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($showQuickViewer)), __LINE__);
        }
        $this->showQuickViewer = $showQuickViewer;
        return $this;
    }
    /**
     * Get rememberQuickViewer value
     * @return bool|null
     */
    public function getRememberQuickViewer()
    {
        return $this->rememberQuickViewer;
    }
    /**
     * Set rememberQuickViewer value
     * @param bool $rememberQuickViewer
     * @return \StructType\DisplayFlags
     */
    public function setRememberQuickViewer($rememberQuickViewer = null)
    {
        // validation for constraint: boolean
        if (!is_null($rememberQuickViewer) && !is_bool($rememberQuickViewer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($rememberQuickViewer)), __LINE__);
        }
        $this->rememberQuickViewer = $rememberQuickViewer;
        return $this;
    }
    /**
     * Get summary value
     * @return bool|null
     */
    public function getSummary()
    {
        return $this->summary;
    }
    /**
     * Set summary value
     * @param bool $summary
     * @return \StructType\DisplayFlags
     */
    public function setSummary($summary = null)
    {
        // validation for constraint: boolean
        if (!is_null($summary) && !is_bool($summary)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($summary)), __LINE__);
        }
        $this->summary = $summary;
        return $this;
    }
    /**
     * Get showGroupLabels value
     * @return bool|null
     */
    public function getShowGroupLabels()
    {
        return $this->showGroupLabels;
    }
    /**
     * Set showGroupLabels value
     * @param bool $showGroupLabels
     * @return \StructType\DisplayFlags
     */
    public function setShowGroupLabels($showGroupLabels = null)
    {
        // validation for constraint: boolean
        if (!is_null($showGroupLabels) && !is_bool($showGroupLabels)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($showGroupLabels)), __LINE__);
        }
        $this->showGroupLabels = $showGroupLabels;
        return $this;
    }
    /**
     * Get showFolderTree value
     * @return bool|null
     */
    public function getShowFolderTree()
    {
        return $this->showFolderTree;
    }
    /**
     * Set showFolderTree value
     * @param bool $showFolderTree
     * @return \StructType\DisplayFlags
     */
    public function setShowFolderTree($showFolderTree = null)
    {
        // validation for constraint: boolean
        if (!is_null($showFolderTree) && !is_bool($showFolderTree)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($showFolderTree)), __LINE__);
        }
        $this->showFolderTree = $showFolderTree;
        return $this;
    }
    /**
     * Get rememberFolderTree value
     * @return bool|null
     */
    public function getRememberFolderTree()
    {
        return $this->rememberFolderTree;
    }
    /**
     * Set rememberFolderTree value
     * @param bool $rememberFolderTree
     * @return \StructType\DisplayFlags
     */
    public function setRememberFolderTree($rememberFolderTree = null)
    {
        // validation for constraint: boolean
        if (!is_null($rememberFolderTree) && !is_bool($rememberFolderTree)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($rememberFolderTree)), __LINE__);
        }
        $this->rememberFolderTree = $rememberFolderTree;
        return $this;
    }
    /**
     * Get showSimpleFolderTree value
     * @return bool|null
     */
    public function getShowSimpleFolderTree()
    {
        return $this->showSimpleFolderTree;
    }
    /**
     * Set showSimpleFolderTree value
     * @param bool $showSimpleFolderTree
     * @return \StructType\DisplayFlags
     */
    public function setShowSimpleFolderTree($showSimpleFolderTree = null)
    {
        // validation for constraint: boolean
        if (!is_null($showSimpleFolderTree) && !is_bool($showSimpleFolderTree)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($showSimpleFolderTree)), __LINE__);
        }
        $this->showSimpleFolderTree = $showSimpleFolderTree;
        return $this;
    }
    /**
     * Get showFullFolderTree value
     * @return bool|null
     */
    public function getShowFullFolderTree()
    {
        return $this->showFullFolderTree;
    }
    /**
     * Set showFullFolderTree value
     * @param bool $showFullFolderTree
     * @return \StructType\DisplayFlags
     */
    public function setShowFullFolderTree($showFullFolderTree = null)
    {
        // validation for constraint: boolean
        if (!is_null($showFullFolderTree) && !is_bool($showFullFolderTree)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($showFullFolderTree)), __LINE__);
        }
        $this->showFullFolderTree = $showFullFolderTree;
        return $this;
    }
    /**
     * Get messagePreview value
     * @return bool|null
     */
    public function getMessagePreview()
    {
        return $this->messagePreview;
    }
    /**
     * Set messagePreview value
     * @param bool $messagePreview
     * @return \StructType\DisplayFlags
     */
    public function setMessagePreview($messagePreview = null)
    {
        // validation for constraint: boolean
        if (!is_null($messagePreview) && !is_bool($messagePreview)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($messagePreview)), __LINE__);
        }
        $this->messagePreview = $messagePreview;
        return $this;
    }
    /**
     * Get hideCompleted value
     * @return bool|null
     */
    public function getHideCompleted()
    {
        return $this->hideCompleted;
    }
    /**
     * Set hideCompleted value
     * @param bool $hideCompleted
     * @return \StructType\DisplayFlags
     */
    public function setHideCompleted($hideCompleted = null)
    {
        // validation for constraint: boolean
        if (!is_null($hideCompleted) && !is_bool($hideCompleted)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($hideCompleted)), __LINE__);
        }
        $this->hideCompleted = $hideCompleted;
        return $this;
    }
    /**
     * Get hideCompletedAfterOneDay value
     * @return bool|null
     */
    public function getHideCompletedAfterOneDay()
    {
        return $this->hideCompletedAfterOneDay;
    }
    /**
     * Set hideCompletedAfterOneDay value
     * @param bool $hideCompletedAfterOneDay
     * @return \StructType\DisplayFlags
     */
    public function setHideCompletedAfterOneDay($hideCompletedAfterOneDay = null)
    {
        // validation for constraint: boolean
        if (!is_null($hideCompletedAfterOneDay) && !is_bool($hideCompletedAfterOneDay)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($hideCompletedAfterOneDay)), __LINE__);
        }
        $this->hideCompletedAfterOneDay = $hideCompletedAfterOneDay;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DisplayFlags
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
