<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EmailAddressList StructType
 * @subpackage Structs
 */
class EmailAddressList extends AbstractStructBase
{
    /**
     * The email
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - ref: tns:email
     * @var string[]
     */
    public $email;
    /**
     * The primary
     * @var string
     */
    public $primary;
    /**
     * Constructor method for EmailAddressList
     * @uses EmailAddressList::setEmail()
     * @uses EmailAddressList::setPrimary()
     * @param string[] $email
     * @param string $primary
     */
    public function __construct(array $email = array(), $primary = null)
    {
        $this
            ->setEmail($email)
            ->setPrimary($primary);
    }
    /**
     * Get email value
     * @return string[]|null
     */
    public function getEmail()
    {
        return $this->email;
    }
    /**
     * Set email value
     * @throws \InvalidArgumentException
     * @param string[] $email
     * @return \StructType\EmailAddressList
     */
    public function setEmail(array $email = array())
    {
        foreach ($email as $emailAddressListEmailItem) {
            // validation for constraint: itemType
            if (!is_string($emailAddressListEmailItem)) {
                throw new \InvalidArgumentException(sprintf('The email property can only contain items of string, "%s" given', is_object($emailAddressListEmailItem) ? get_class($emailAddressListEmailItem) : gettype($emailAddressListEmailItem)), __LINE__);
            }
        }
        $this->email = $email;
        return $this;
    }
    /**
     * Add item to email value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \StructType\EmailAddressList
     */
    public function addToEmail($item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The email property can only contain items of string, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->email[] = $item;
        return $this;
    }
    /**
     * Get primary value
     * @return string|null
     */
    public function getPrimary()
    {
        return $this->primary;
    }
    /**
     * Set primary value
     * @param string $primary
     * @return \StructType\EmailAddressList
     */
    public function setPrimary($primary = null)
    {
        // validation for constraint: string
        if (!is_null($primary) && !is_string($primary)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($primary)), __LINE__);
        }
        $this->primary = $primary;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\EmailAddressList
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
