<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Filter StructType
 * @subpackage Structs
 */
class Filter extends AbstractStructBase
{
    /**
     * The element
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\FilterElement
     */
    public $element;
    /**
     * Constructor method for Filter
     * @uses Filter::setElement()
     * @param \StructType\FilterElement $element
     */
    public function __construct(\StructType\FilterElement $element = null)
    {
        $this
            ->setElement($element);
    }
    /**
     * Get element value
     * @return \StructType\FilterElement|null
     */
    public function getElement()
    {
        return $this->element;
    }
    /**
     * Set element value
     * @param \StructType\FilterElement $element
     * @return \StructType\Filter
     */
    public function setElement(\StructType\FilterElement $element = null)
    {
        $this->element = $element;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Filter
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
