<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for From StructType
 * @subpackage Structs
 */
class From extends NameAndEmail
{
    /**
     * The replyTo
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $replyTo;
    /**
     * Constructor method for From
     * @uses From::setReplyTo()
     * @param string $replyTo
     */
    public function __construct($replyTo = null)
    {
        $this
            ->setReplyTo($replyTo);
    }
    /**
     * Get replyTo value
     * @return string|null
     */
    public function getReplyTo()
    {
        return $this->replyTo;
    }
    /**
     * Set replyTo value
     * @param string $replyTo
     * @return \StructType\From
     */
    public function setReplyTo($replyTo = null)
    {
        // validation for constraint: string
        if (!is_null($replyTo) && !is_string($replyTo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($replyTo)), __LINE__);
        }
        $this->replyTo = $replyTo;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\From
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
