<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getCategoryListResponse StructType
 * @subpackage Structs
 */
class GetCategoryListResponse extends AbstractStructBase
{
    /**
     * The categories
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CategoryList
     */
    public $categories;
    /**
     * The status
     * @var \StructType\Status
     */
    public $status;
    /**
     * Constructor method for getCategoryListResponse
     * @uses GetCategoryListResponse::setCategories()
     * @uses GetCategoryListResponse::setStatus()
     * @param \StructType\CategoryList $categories
     * @param \StructType\Status $status
     */
    public function __construct(\StructType\CategoryList $categories = null, \StructType\Status $status = null)
    {
        $this
            ->setCategories($categories)
            ->setStatus($status);
    }
    /**
     * Get categories value
     * @return \StructType\CategoryList|null
     */
    public function getCategories()
    {
        return $this->categories;
    }
    /**
     * Set categories value
     * @param \StructType\CategoryList $categories
     * @return \StructType\GetCategoryListResponse
     */
    public function setCategories(\StructType\CategoryList $categories = null)
    {
        $this->categories = $categories;
        return $this;
    }
    /**
     * Get status value
     * @return \StructType\Status|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @param \StructType\Status $status
     * @return \StructType\GetCategoryListResponse
     */
    public function setStatus(\StructType\Status $status = null)
    {
        $this->status = $status;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetCategoryListResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
