<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getFolderResponse StructType
 * @subpackage Structs
 */
class GetFolderResponse extends AbstractStructBase
{
    /**
     * The folder
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Folder
     */
    public $folder;
    /**
     * The status
     * @var \StructType\Status
     */
    public $status;
    /**
     * Constructor method for getFolderResponse
     * @uses GetFolderResponse::setFolder()
     * @uses GetFolderResponse::setStatus()
     * @param \StructType\Folder $folder
     * @param \StructType\Status $status
     */
    public function __construct(\StructType\Folder $folder = null, \StructType\Status $status = null)
    {
        $this
            ->setFolder($folder)
            ->setStatus($status);
    }
    /**
     * Get folder value
     * @return \StructType\Folder|null
     */
    public function getFolder()
    {
        return $this->folder;
    }
    /**
     * Set folder value
     * @param \StructType\Folder $folder
     * @return \StructType\GetFolderResponse
     */
    public function setFolder(\StructType\Folder $folder = null)
    {
        $this->folder = $folder;
        return $this;
    }
    /**
     * Get status value
     * @return \StructType\Status|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @param \StructType\Status $status
     * @return \StructType\GetFolderResponse
     */
    public function setStatus(\StructType\Status $status = null)
    {
        $this->status = $status;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetFolderResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
