<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getItemsResponse StructType
 * @subpackage Structs
 */
class GetItemsResponse extends AbstractStructBase
{
    /**
     * The items
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Items
     */
    public $items;
    /**
     * The sids
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $sids;
    /**
     * The status
     * @var \StructType\Status
     */
    public $status;
    /**
     * Constructor method for getItemsResponse
     * @uses GetItemsResponse::setItems()
     * @uses GetItemsResponse::setSids()
     * @uses GetItemsResponse::setStatus()
     * @param \StructType\Items $items
     * @param string $sids
     * @param \StructType\Status $status
     */
    public function __construct(\StructType\Items $items = null, $sids = null, \StructType\Status $status = null)
    {
        $this
            ->setItems($items)
            ->setSids($sids)
            ->setStatus($status);
    }
    /**
     * Get items value
     * @return \StructType\Items|null
     */
    public function getItems()
    {
        return $this->items;
    }
    /**
     * Set items value
     * @param \StructType\Items $items
     * @return \StructType\GetItemsResponse
     */
    public function setItems(\StructType\Items $items = null)
    {
        $this->items = $items;
        return $this;
    }
    /**
     * Get sids value
     * @return string|null
     */
    public function getSids()
    {
        return $this->sids;
    }
    /**
     * Set sids value
     * @param string $sids
     * @return \StructType\GetItemsResponse
     */
    public function setSids($sids = null)
    {
        // validation for constraint: string
        if (!is_null($sids) && !is_string($sids)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($sids)), __LINE__);
        }
        $this->sids = $sids;
        return $this;
    }
    /**
     * Get status value
     * @return \StructType\Status|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @param \StructType\Status $status
     * @return \StructType\GetItemsResponse
     */
    public function setStatus(\StructType\Status $status = null)
    {
        $this->status = $status;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetItemsResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
