<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getJunkEntriesRequest StructType
 * @subpackage Structs
 */
class GetJunkEntriesRequest extends AbstractStructBase
{
    /**
     * The container
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $container;
    /**
     * Constructor method for getJunkEntriesRequest
     * @uses GetJunkEntriesRequest::setContainer()
     * @param string $container
     */
    public function __construct($container = null)
    {
        $this
            ->setContainer($container);
    }
    /**
     * Get container value
     * @return string|null
     */
    public function getContainer()
    {
        return $this->container;
    }
    /**
     * Set container value
     * @uses \EnumType\JunkHandlingListType::valueIsValid()
     * @uses \EnumType\JunkHandlingListType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $container
     * @return \StructType\GetJunkEntriesRequest
     */
    public function setContainer($container = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\JunkHandlingListType::valueIsValid($container)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $container, implode(', ', \EnumType\JunkHandlingListType::getValidValues())), __LINE__);
        }
        $this->container = $container;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetJunkEntriesRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
