<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getSettingsRequest StructType
 * @subpackage Structs
 */
class GetSettingsRequest extends AbstractStructBase
{
    /**
     * The id
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $id;
    /**
     * The reload
     * Meta informations extracted from the WSDL
     * - default: 0
     * - minOccurs: 0
     * @var bool
     */
    public $reload;
    /**
     * Constructor method for getSettingsRequest
     * @uses GetSettingsRequest::setId()
     * @uses GetSettingsRequest::setReload()
     * @param string $id
     * @param bool $reload
     */
    public function __construct($id = null, $reload = false)
    {
        $this
            ->setId($id)
            ->setReload($reload);
    }
    /**
     * Get id value
     * @return string|null
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param string $id
     * @return \StructType\GetSettingsRequest
     */
    public function setId($id = null)
    {
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get reload value
     * @return bool|null
     */
    public function getReload()
    {
        return $this->reload;
    }
    /**
     * Set reload value
     * @param bool $reload
     * @return \StructType\GetSettingsRequest
     */
    public function setReload($reload = false)
    {
        // validation for constraint: boolean
        if (!is_null($reload) && !is_bool($reload)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($reload)), __LINE__);
        }
        $this->reload = $reload;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetSettingsRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
