<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getSettingsResponse StructType
 * @subpackage Structs
 */
class GetSettingsResponse extends AbstractStructBase
{
    /**
     * The settings
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Settings
     */
    public $settings;
    /**
     * The status
     * @var \StructType\Status
     */
    public $status;
    /**
     * Constructor method for getSettingsResponse
     * @uses GetSettingsResponse::setSettings()
     * @uses GetSettingsResponse::setStatus()
     * @param \StructType\Settings $settings
     * @param \StructType\Status $status
     */
    public function __construct(\StructType\Settings $settings = null, \StructType\Status $status = null)
    {
        $this
            ->setSettings($settings)
            ->setStatus($status);
    }
    /**
     * Get settings value
     * @return \StructType\Settings|null
     */
    public function getSettings()
    {
        return $this->settings;
    }
    /**
     * Set settings value
     * @param \StructType\Settings $settings
     * @return \StructType\GetSettingsResponse
     */
    public function setSettings(\StructType\Settings $settings = null)
    {
        $this->settings = $settings;
        return $this;
    }
    /**
     * Get status value
     * @return \StructType\Status|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @param \StructType\Status $status
     * @return \StructType\GetSettingsResponse
     */
    public function setStatus(\StructType\Status $status = null)
    {
        $this->status = $status;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetSettingsResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
