<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getTimestampRequest StructType
 * @subpackage Structs
 */
class GetTimestampRequest extends AbstractStructBase
{
    /**
     * The backup
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $backup;
    /**
     * The retention
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $retention;
    /**
     * The noop
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $noop;
    /**
     * The retentionModified
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $retentionModified;
    /**
     * Constructor method for getTimestampRequest
     * @uses GetTimestampRequest::setBackup()
     * @uses GetTimestampRequest::setRetention()
     * @uses GetTimestampRequest::setNoop()
     * @uses GetTimestampRequest::setRetentionModified()
     * @param bool $backup
     * @param bool $retention
     * @param bool $noop
     * @param bool $retentionModified
     */
    public function __construct($backup = null, $retention = null, $noop = null, $retentionModified = null)
    {
        $this
            ->setBackup($backup)
            ->setRetention($retention)
            ->setNoop($noop)
            ->setRetentionModified($retentionModified);
    }
    /**
     * Get backup value
     * @return bool|null
     */
    public function getBackup()
    {
        return $this->backup;
    }
    /**
     * Set backup value
     * @param bool $backup
     * @return \StructType\GetTimestampRequest
     */
    public function setBackup($backup = null)
    {
        // validation for constraint: boolean
        if (!is_null($backup) && !is_bool($backup)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($backup)), __LINE__);
        }
        $this->backup = $backup;
        return $this;
    }
    /**
     * Get retention value
     * @return bool|null
     */
    public function getRetention()
    {
        return $this->retention;
    }
    /**
     * Set retention value
     * @param bool $retention
     * @return \StructType\GetTimestampRequest
     */
    public function setRetention($retention = null)
    {
        // validation for constraint: boolean
        if (!is_null($retention) && !is_bool($retention)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($retention)), __LINE__);
        }
        $this->retention = $retention;
        return $this;
    }
    /**
     * Get noop value
     * @return bool|null
     */
    public function getNoop()
    {
        return $this->noop;
    }
    /**
     * Set noop value
     * @param bool $noop
     * @return \StructType\GetTimestampRequest
     */
    public function setNoop($noop = null)
    {
        // validation for constraint: boolean
        if (!is_null($noop) && !is_bool($noop)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($noop)), __LINE__);
        }
        $this->noop = $noop;
        return $this;
    }
    /**
     * Get retentionModified value
     * @return bool|null
     */
    public function getRetentionModified()
    {
        return $this->retentionModified;
    }
    /**
     * Set retentionModified value
     * @param bool $retentionModified
     * @return \StructType\GetTimestampRequest
     */
    public function setRetentionModified($retentionModified = null)
    {
        // validation for constraint: boolean
        if (!is_null($retentionModified) && !is_bool($retentionModified)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($retentionModified)), __LINE__);
        }
        $this->retentionModified = $retentionModified;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetTimestampRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
