<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getUnreadRequest StructType
 * @subpackage Structs
 */
class GetUnreadRequest extends AbstractStructBase
{
    /**
     * The startDate
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - ref: types:startDate
     * @var string
     */
    public $startDate;
    /**
     * The types
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $types;
    /**
     * The source
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $source;
    /**
     * Constructor method for getUnreadRequest
     * @uses GetUnreadRequest::setStartDate()
     * @uses GetUnreadRequest::setTypes()
     * @uses GetUnreadRequest::setSource()
     * @param string $startDate
     * @param string $types
     * @param string $source
     */
    public function __construct($startDate = null, $types = null, $source = null)
    {
        $this
            ->setStartDate($startDate)
            ->setTypes($types)
            ->setSource($source);
    }
    /**
     * Get startDate value
     * @return string|null
     */
    public function getStartDate()
    {
        return $this->startDate;
    }
    /**
     * Set startDate value
     * @param string $startDate
     * @return \StructType\GetUnreadRequest
     */
    public function setStartDate($startDate = null)
    {
        // validation for constraint: string
        if (!is_null($startDate) && !is_string($startDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($startDate)), __LINE__);
        }
        $this->startDate = $startDate;
        return $this;
    }
    /**
     * Get types value
     * @return string|null
     */
    public function getTypes()
    {
        return $this->types;
    }
    /**
     * Set types value
     * @param string $types
     * @return \StructType\GetUnreadRequest
     */
    public function setTypes($types = null)
    {
        // validation for constraint: string
        if (!is_null($types) && !is_string($types)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($types)), __LINE__);
        }
        $this->types = $types;
        return $this;
    }
    /**
     * Get source value
     * @return string|null
     */
    public function getSource()
    {
        return $this->source;
    }
    /**
     * Set source value
     * @param string $source
     * @return \StructType\GetUnreadRequest
     */
    public function setSource($source = null)
    {
        // validation for constraint: string
        if (!is_null($source) && !is_string($source)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($source)), __LINE__);
        }
        $this->source = $source;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetUnreadRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
