<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InternetStatusTracking StructType
 * @subpackage Structs
 */
class InternetStatusTracking extends AbstractStructBase
{
    /**
     * The enableDeliveryConfirmaion
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $enableDeliveryConfirmaion;
    /**
     * The deliveryConfirmaionToMyMailbox
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $deliveryConfirmaionToMyMailbox;
    /**
     * Constructor method for InternetStatusTracking
     * @uses InternetStatusTracking::setEnableDeliveryConfirmaion()
     * @uses InternetStatusTracking::setDeliveryConfirmaionToMyMailbox()
     * @param bool $enableDeliveryConfirmaion
     * @param bool $deliveryConfirmaionToMyMailbox
     */
    public function __construct($enableDeliveryConfirmaion = null, $deliveryConfirmaionToMyMailbox = null)
    {
        $this
            ->setEnableDeliveryConfirmaion($enableDeliveryConfirmaion)
            ->setDeliveryConfirmaionToMyMailbox($deliveryConfirmaionToMyMailbox);
    }
    /**
     * Get enableDeliveryConfirmaion value
     * @return bool|null
     */
    public function getEnableDeliveryConfirmaion()
    {
        return $this->enableDeliveryConfirmaion;
    }
    /**
     * Set enableDeliveryConfirmaion value
     * @param bool $enableDeliveryConfirmaion
     * @return \StructType\InternetStatusTracking
     */
    public function setEnableDeliveryConfirmaion($enableDeliveryConfirmaion = null)
    {
        // validation for constraint: boolean
        if (!is_null($enableDeliveryConfirmaion) && !is_bool($enableDeliveryConfirmaion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($enableDeliveryConfirmaion)), __LINE__);
        }
        $this->enableDeliveryConfirmaion = $enableDeliveryConfirmaion;
        return $this;
    }
    /**
     * Get deliveryConfirmaionToMyMailbox value
     * @return bool|null
     */
    public function getDeliveryConfirmaionToMyMailbox()
    {
        return $this->deliveryConfirmaionToMyMailbox;
    }
    /**
     * Set deliveryConfirmaionToMyMailbox value
     * @param bool $deliveryConfirmaionToMyMailbox
     * @return \StructType\InternetStatusTracking
     */
    public function setDeliveryConfirmaionToMyMailbox($deliveryConfirmaionToMyMailbox = null)
    {
        // validation for constraint: boolean
        if (!is_null($deliveryConfirmaionToMyMailbox) && !is_bool($deliveryConfirmaionToMyMailbox)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($deliveryConfirmaionToMyMailbox)), __LINE__);
        }
        $this->deliveryConfirmaionToMyMailbox = $deliveryConfirmaionToMyMailbox;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\InternetStatusTracking
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
