<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ItemChanges StructType
 * Meta informations extracted from the WSDL
 * - type: xs:boolean
 * - use: optional
 * @subpackage Structs
 */
class ItemChanges extends AbstractStructBase
{
    /**
     * The add
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Item
     */
    public $add;
    /**
     * The delete
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Item
     */
    public $delete;
    /**
     * The update
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Item
     */
    public $update;
    /**
     * Constructor method for ItemChanges
     * @uses ItemChanges::setAdd()
     * @uses ItemChanges::setDelete()
     * @uses ItemChanges::setUpdate()
     * @param \StructType\Item $add
     * @param \StructType\Item $delete
     * @param \StructType\Item $update
     */
    public function __construct(\StructType\Item $add = null, \StructType\Item $delete = null, \StructType\Item $update = null)
    {
        $this
            ->setAdd($add)
            ->setDelete($delete)
            ->setUpdate($update);
    }
    /**
     * Get add value
     * @return \StructType\Item|null
     */
    public function getAdd()
    {
        return $this->add;
    }
    /**
     * Set add value
     * @param \StructType\Item $add
     * @return \StructType\ItemChanges
     */
    public function setAdd(\StructType\Item $add = null)
    {
        $this->add = $add;
        return $this;
    }
    /**
     * Get delete value
     * @return \StructType\Item|null
     */
    public function getDelete()
    {
        return $this->delete;
    }
    /**
     * Set delete value
     * @param \StructType\Item $delete
     * @return \StructType\ItemChanges
     */
    public function setDelete(\StructType\Item $delete = null)
    {
        $this->delete = $delete;
        return $this;
    }
    /**
     * Get update value
     * @return \StructType\Item|null
     */
    public function getUpdate()
    {
        return $this->update;
    }
    /**
     * Set update value
     * @param \StructType\Item $update
     * @return \StructType\ItemChanges
     */
    public function setUpdate(\StructType\Item $update = null)
    {
        $this->update = $update;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ItemChanges
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
