<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for modifySettingsRequest StructType
 * @subpackage Structs
 */
class ModifySettingsRequest extends AbstractStructBase
{
    /**
     * The settings
     * @var \StructType\SettingsList
     */
    public $settings;
    /**
     * Constructor method for modifySettingsRequest
     * @uses ModifySettingsRequest::setSettings()
     * @param \StructType\SettingsList $settings
     */
    public function __construct(\StructType\SettingsList $settings = null)
    {
        $this
            ->setSettings($settings);
    }
    /**
     * Get settings value
     * @return \StructType\SettingsList|null
     */
    public function getSettings()
    {
        return $this->settings;
    }
    /**
     * Set settings value
     * @param \StructType\SettingsList $settings
     * @return \StructType\ModifySettingsRequest
     */
    public function setSettings(\StructType\SettingsList $settings = null)
    {
        $this->settings = $settings;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ModifySettingsRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
