<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PhoneFlags StructType
 * @subpackage Structs
 */
class PhoneFlags extends AbstractStructBase
{
    /**
     * The called
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $called;
    /**
     * The pleaseCall
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $pleaseCall;
    /**
     * The willCall
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $willCall;
    /**
     * The returnedYourCall
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $returnedYourCall;
    /**
     * The wantsToSeeYou
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $wantsToSeeYou;
    /**
     * The cameToSeeYou
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $cameToSeeYou;
    /**
     * The urgent
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $urgent;
    /**
     * Constructor method for PhoneFlags
     * @uses PhoneFlags::setCalled()
     * @uses PhoneFlags::setPleaseCall()
     * @uses PhoneFlags::setWillCall()
     * @uses PhoneFlags::setReturnedYourCall()
     * @uses PhoneFlags::setWantsToSeeYou()
     * @uses PhoneFlags::setCameToSeeYou()
     * @uses PhoneFlags::setUrgent()
     * @param bool $called
     * @param bool $pleaseCall
     * @param bool $willCall
     * @param bool $returnedYourCall
     * @param bool $wantsToSeeYou
     * @param bool $cameToSeeYou
     * @param bool $urgent
     */
    public function __construct($called = null, $pleaseCall = null, $willCall = null, $returnedYourCall = null, $wantsToSeeYou = null, $cameToSeeYou = null, $urgent = null)
    {
        $this
            ->setCalled($called)
            ->setPleaseCall($pleaseCall)
            ->setWillCall($willCall)
            ->setReturnedYourCall($returnedYourCall)
            ->setWantsToSeeYou($wantsToSeeYou)
            ->setCameToSeeYou($cameToSeeYou)
            ->setUrgent($urgent);
    }
    /**
     * Get called value
     * @return bool|null
     */
    public function getCalled()
    {
        return $this->called;
    }
    /**
     * Set called value
     * @param bool $called
     * @return \StructType\PhoneFlags
     */
    public function setCalled($called = null)
    {
        // validation for constraint: boolean
        if (!is_null($called) && !is_bool($called)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($called)), __LINE__);
        }
        $this->called = $called;
        return $this;
    }
    /**
     * Get pleaseCall value
     * @return bool|null
     */
    public function getPleaseCall()
    {
        return $this->pleaseCall;
    }
    /**
     * Set pleaseCall value
     * @param bool $pleaseCall
     * @return \StructType\PhoneFlags
     */
    public function setPleaseCall($pleaseCall = null)
    {
        // validation for constraint: boolean
        if (!is_null($pleaseCall) && !is_bool($pleaseCall)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($pleaseCall)), __LINE__);
        }
        $this->pleaseCall = $pleaseCall;
        return $this;
    }
    /**
     * Get willCall value
     * @return bool|null
     */
    public function getWillCall()
    {
        return $this->willCall;
    }
    /**
     * Set willCall value
     * @param bool $willCall
     * @return \StructType\PhoneFlags
     */
    public function setWillCall($willCall = null)
    {
        // validation for constraint: boolean
        if (!is_null($willCall) && !is_bool($willCall)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($willCall)), __LINE__);
        }
        $this->willCall = $willCall;
        return $this;
    }
    /**
     * Get returnedYourCall value
     * @return bool|null
     */
    public function getReturnedYourCall()
    {
        return $this->returnedYourCall;
    }
    /**
     * Set returnedYourCall value
     * @param bool $returnedYourCall
     * @return \StructType\PhoneFlags
     */
    public function setReturnedYourCall($returnedYourCall = null)
    {
        // validation for constraint: boolean
        if (!is_null($returnedYourCall) && !is_bool($returnedYourCall)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($returnedYourCall)), __LINE__);
        }
        $this->returnedYourCall = $returnedYourCall;
        return $this;
    }
    /**
     * Get wantsToSeeYou value
     * @return bool|null
     */
    public function getWantsToSeeYou()
    {
        return $this->wantsToSeeYou;
    }
    /**
     * Set wantsToSeeYou value
     * @param bool $wantsToSeeYou
     * @return \StructType\PhoneFlags
     */
    public function setWantsToSeeYou($wantsToSeeYou = null)
    {
        // validation for constraint: boolean
        if (!is_null($wantsToSeeYou) && !is_bool($wantsToSeeYou)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($wantsToSeeYou)), __LINE__);
        }
        $this->wantsToSeeYou = $wantsToSeeYou;
        return $this;
    }
    /**
     * Get cameToSeeYou value
     * @return bool|null
     */
    public function getCameToSeeYou()
    {
        return $this->cameToSeeYou;
    }
    /**
     * Set cameToSeeYou value
     * @param bool $cameToSeeYou
     * @return \StructType\PhoneFlags
     */
    public function setCameToSeeYou($cameToSeeYou = null)
    {
        // validation for constraint: boolean
        if (!is_null($cameToSeeYou) && !is_bool($cameToSeeYou)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($cameToSeeYou)), __LINE__);
        }
        $this->cameToSeeYou = $cameToSeeYou;
        return $this;
    }
    /**
     * Get urgent value
     * @return bool|null
     */
    public function getUrgent()
    {
        return $this->urgent;
    }
    /**
     * Set urgent value
     * @param bool $urgent
     * @return \StructType\PhoneFlags
     */
    public function setUrgent($urgent = null)
    {
        // validation for constraint: boolean
        if (!is_null($urgent) && !is_bool($urgent)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($urgent)), __LINE__);
        }
        $this->urgent = $urgent;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PhoneFlags
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
