<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for removeEventsRequest StructType
 * @subpackage Structs
 */
class RemoveEventsRequest extends AbstractStructBase
{
    /**
     * The key
     * Meta informations extracted from the WSDL
     * - ref: tns:key
     * @var string
     */
    public $key;
    /**
     * The from
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $from;
    /**
     * The until
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $until;
    /**
     * Constructor method for removeEventsRequest
     * @uses RemoveEventsRequest::setKey()
     * @uses RemoveEventsRequest::setFrom()
     * @uses RemoveEventsRequest::setUntil()
     * @param string $key
     * @param string $from
     * @param string $until
     */
    public function __construct($key = null, $from = null, $until = null)
    {
        $this
            ->setKey($key)
            ->setFrom($from)
            ->setUntil($until);
    }
    /**
     * Get key value
     * @return string|null
     */
    public function getKey()
    {
        return $this->key;
    }
    /**
     * Set key value
     * @param string $key
     * @return \StructType\RemoveEventsRequest
     */
    public function setKey($key = null)
    {
        // validation for constraint: string
        if (!is_null($key) && !is_string($key)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($key)), __LINE__);
        }
        $this->key = $key;
        return $this;
    }
    /**
     * Get from value
     * @return string|null
     */
    public function getFrom()
    {
        return $this->from;
    }
    /**
     * Set from value
     * @param string $from
     * @return \StructType\RemoveEventsRequest
     */
    public function setFrom($from = null)
    {
        // validation for constraint: string
        if (!is_null($from) && !is_string($from)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($from)), __LINE__);
        }
        $this->from = $from;
        return $this;
    }
    /**
     * Get until value
     * @return string|null
     */
    public function getUntil()
    {
        return $this->until;
    }
    /**
     * Set until value
     * @param string $until
     * @return \StructType\RemoveEventsRequest
     */
    public function setUntil($until = null)
    {
        // validation for constraint: string
        if (!is_null($until) && !is_string($until)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($until)), __LINE__);
        }
        $this->until = $until;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RemoveEventsRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
