<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for resolveRequest StructType
 * @subpackage Structs
 */
class ResolveRequest extends AbstractStructBase
{
    /**
     * The recipients
     * @var \StructType\RecipientList
     */
    public $recipients;
    /**
     * Constructor method for resolveRequest
     * @uses ResolveRequest::setRecipients()
     * @param \StructType\RecipientList $recipients
     */
    public function __construct(\StructType\RecipientList $recipients = null)
    {
        $this
            ->setRecipients($recipients);
    }
    /**
     * Get recipients value
     * @return \StructType\RecipientList|null
     */
    public function getRecipients()
    {
        return $this->recipients;
    }
    /**
     * Set recipients value
     * @param \StructType\RecipientList $recipients
     * @return \StructType\ResolveRequest
     */
    public function setRecipients(\StructType\RecipientList $recipients = null)
    {
        $this->recipients = $recipients;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ResolveRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
