<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for resolveResponse StructType
 * @subpackage Structs
 */
class ResolveResponse extends AbstractStructBase
{
    /**
     * The recipients
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\RecipientList
     */
    public $recipients;
    /**
     * The status
     * @var \StructType\Status
     */
    public $status;
    /**
     * Constructor method for resolveResponse
     * @uses ResolveResponse::setRecipients()
     * @uses ResolveResponse::setStatus()
     * @param \StructType\RecipientList $recipients
     * @param \StructType\Status $status
     */
    public function __construct(\StructType\RecipientList $recipients = null, \StructType\Status $status = null)
    {
        $this
            ->setRecipients($recipients)
            ->setStatus($status);
    }
    /**
     * Get recipients value
     * @return \StructType\RecipientList|null
     */
    public function getRecipients()
    {
        return $this->recipients;
    }
    /**
     * Set recipients value
     * @param \StructType\RecipientList $recipients
     * @return \StructType\ResolveResponse
     */
    public function setRecipients(\StructType\RecipientList $recipients = null)
    {
        $this->recipients = $recipients;
        return $this;
    }
    /**
     * Get status value
     * @return \StructType\Status|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @param \StructType\Status $status
     * @return \StructType\ResolveResponse
     */
    public function setStatus(\StructType\Status $status = null)
    {
        $this->status = $status;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ResolveResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
