<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Rights StructType
 * Meta informations extracted from the WSDL
 * - minOccurs: 0
 * - type: xs:boolean
 * @subpackage Structs
 */
class Rights extends AbstractStructBase
{
    /**
     * The read
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $read;
    /**
     * The add
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $add;
    /**
     * The edit
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $edit;
    /**
     * The delete
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $delete;
    /**
     * The share
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $share;
    /**
     * The manage
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $manage;
    /**
     * Constructor method for Rights
     * @uses Rights::setRead()
     * @uses Rights::setAdd()
     * @uses Rights::setEdit()
     * @uses Rights::setDelete()
     * @uses Rights::setShare()
     * @uses Rights::setManage()
     * @param bool $read
     * @param bool $add
     * @param bool $edit
     * @param bool $delete
     * @param bool $share
     * @param bool $manage
     */
    public function __construct($read = null, $add = null, $edit = null, $delete = null, $share = null, $manage = null)
    {
        $this
            ->setRead($read)
            ->setAdd($add)
            ->setEdit($edit)
            ->setDelete($delete)
            ->setShare($share)
            ->setManage($manage);
    }
    /**
     * Get read value
     * @return bool|null
     */
    public function getRead()
    {
        return $this->read;
    }
    /**
     * Set read value
     * @param bool $read
     * @return \StructType\Rights
     */
    public function setRead($read = null)
    {
        // validation for constraint: boolean
        if (!is_null($read) && !is_bool($read)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($read)), __LINE__);
        }
        $this->read = $read;
        return $this;
    }
    /**
     * Get add value
     * @return bool|null
     */
    public function getAdd()
    {
        return $this->add;
    }
    /**
     * Set add value
     * @param bool $add
     * @return \StructType\Rights
     */
    public function setAdd($add = null)
    {
        // validation for constraint: boolean
        if (!is_null($add) && !is_bool($add)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($add)), __LINE__);
        }
        $this->add = $add;
        return $this;
    }
    /**
     * Get edit value
     * @return bool|null
     */
    public function getEdit()
    {
        return $this->edit;
    }
    /**
     * Set edit value
     * @param bool $edit
     * @return \StructType\Rights
     */
    public function setEdit($edit = null)
    {
        // validation for constraint: boolean
        if (!is_null($edit) && !is_bool($edit)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($edit)), __LINE__);
        }
        $this->edit = $edit;
        return $this;
    }
    /**
     * Get delete value
     * @return bool|null
     */
    public function getDelete()
    {
        return $this->delete;
    }
    /**
     * Set delete value
     * @param bool $delete
     * @return \StructType\Rights
     */
    public function setDelete($delete = null)
    {
        // validation for constraint: boolean
        if (!is_null($delete) && !is_bool($delete)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($delete)), __LINE__);
        }
        $this->delete = $delete;
        return $this;
    }
    /**
     * Get share value
     * @return bool|null
     */
    public function getShare()
    {
        return $this->share;
    }
    /**
     * Set share value
     * @param bool $share
     * @return \StructType\Rights
     */
    public function setShare($share = null)
    {
        // validation for constraint: boolean
        if (!is_null($share) && !is_bool($share)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($share)), __LINE__);
        }
        $this->share = $share;
        return $this;
    }
    /**
     * Get manage value
     * @return bool|null
     */
    public function getManage()
    {
        return $this->manage;
    }
    /**
     * Set manage value
     * @param bool $manage
     * @return \StructType\Rights
     */
    public function setManage($manage = null)
    {
        // validation for constraint: boolean
        if (!is_null($manage) && !is_bool($manage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($manage)), __LINE__);
        }
        $this->manage = $manage;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Rights
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
