<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ServerFlags StructType
 * @subpackage Structs
 */
class ServerFlags extends AbstractStructBase
{
    /**
     * The savePassword
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $savePassword;
    /**
     * The useIncomingAuth
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $useIncomingAuth;
    /**
     * The secureConnection
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $secureConnection;
    /**
     * The authRequired
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $authRequired;
    /**
     * The IMAP_ACL
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $IMAP_ACL;
    /**
     * The netMail
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $netMail;
    /**
     * The SSLRequired
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $SSLRequired;
    /**
     * Constructor method for ServerFlags
     * @uses ServerFlags::setSavePassword()
     * @uses ServerFlags::setUseIncomingAuth()
     * @uses ServerFlags::setSecureConnection()
     * @uses ServerFlags::setAuthRequired()
     * @uses ServerFlags::setIMAP_ACL()
     * @uses ServerFlags::setNetMail()
     * @uses ServerFlags::setSSLRequired()
     * @param bool $savePassword
     * @param bool $useIncomingAuth
     * @param bool $secureConnection
     * @param bool $authRequired
     * @param bool $iMAP_ACL
     * @param bool $netMail
     * @param bool $sSLRequired
     */
    public function __construct($savePassword = null, $useIncomingAuth = null, $secureConnection = null, $authRequired = null, $iMAP_ACL = null, $netMail = null, $sSLRequired = null)
    {
        $this
            ->setSavePassword($savePassword)
            ->setUseIncomingAuth($useIncomingAuth)
            ->setSecureConnection($secureConnection)
            ->setAuthRequired($authRequired)
            ->setIMAP_ACL($iMAP_ACL)
            ->setNetMail($netMail)
            ->setSSLRequired($sSLRequired);
    }
    /**
     * Get savePassword value
     * @return bool|null
     */
    public function getSavePassword()
    {
        return $this->savePassword;
    }
    /**
     * Set savePassword value
     * @param bool $savePassword
     * @return \StructType\ServerFlags
     */
    public function setSavePassword($savePassword = null)
    {
        // validation for constraint: boolean
        if (!is_null($savePassword) && !is_bool($savePassword)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($savePassword)), __LINE__);
        }
        $this->savePassword = $savePassword;
        return $this;
    }
    /**
     * Get useIncomingAuth value
     * @return bool|null
     */
    public function getUseIncomingAuth()
    {
        return $this->useIncomingAuth;
    }
    /**
     * Set useIncomingAuth value
     * @param bool $useIncomingAuth
     * @return \StructType\ServerFlags
     */
    public function setUseIncomingAuth($useIncomingAuth = null)
    {
        // validation for constraint: boolean
        if (!is_null($useIncomingAuth) && !is_bool($useIncomingAuth)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($useIncomingAuth)), __LINE__);
        }
        $this->useIncomingAuth = $useIncomingAuth;
        return $this;
    }
    /**
     * Get secureConnection value
     * @return bool|null
     */
    public function getSecureConnection()
    {
        return $this->secureConnection;
    }
    /**
     * Set secureConnection value
     * @param bool $secureConnection
     * @return \StructType\ServerFlags
     */
    public function setSecureConnection($secureConnection = null)
    {
        // validation for constraint: boolean
        if (!is_null($secureConnection) && !is_bool($secureConnection)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($secureConnection)), __LINE__);
        }
        $this->secureConnection = $secureConnection;
        return $this;
    }
    /**
     * Get authRequired value
     * @return bool|null
     */
    public function getAuthRequired()
    {
        return $this->authRequired;
    }
    /**
     * Set authRequired value
     * @param bool $authRequired
     * @return \StructType\ServerFlags
     */
    public function setAuthRequired($authRequired = null)
    {
        // validation for constraint: boolean
        if (!is_null($authRequired) && !is_bool($authRequired)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($authRequired)), __LINE__);
        }
        $this->authRequired = $authRequired;
        return $this;
    }
    /**
     * Get IMAP_ACL value
     * @return bool|null
     */
    public function getIMAP_ACL()
    {
        return $this->IMAP_ACL;
    }
    /**
     * Set IMAP_ACL value
     * @param bool $iMAP_ACL
     * @return \StructType\ServerFlags
     */
    public function setIMAP_ACL($iMAP_ACL = null)
    {
        // validation for constraint: boolean
        if (!is_null($iMAP_ACL) && !is_bool($iMAP_ACL)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($iMAP_ACL)), __LINE__);
        }
        $this->IMAP_ACL = $iMAP_ACL;
        return $this;
    }
    /**
     * Get netMail value
     * @return bool|null
     */
    public function getNetMail()
    {
        return $this->netMail;
    }
    /**
     * Set netMail value
     * @param bool $netMail
     * @return \StructType\ServerFlags
     */
    public function setNetMail($netMail = null)
    {
        // validation for constraint: boolean
        if (!is_null($netMail) && !is_bool($netMail)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($netMail)), __LINE__);
        }
        $this->netMail = $netMail;
        return $this;
    }
    /**
     * Get SSLRequired value
     * @return bool|null
     */
    public function getSSLRequired()
    {
        return $this->SSLRequired;
    }
    /**
     * Set SSLRequired value
     * @param bool $sSLRequired
     * @return \StructType\ServerFlags
     */
    public function setSSLRequired($sSLRequired = null)
    {
        // validation for constraint: boolean
        if (!is_null($sSLRequired) && !is_bool($sSLRequired)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($sSLRequired)), __LINE__);
        }
        $this->SSLRequired = $sSLRequired;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ServerFlags
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
