<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for StatusTrackingFlags StructType
 * @subpackage Structs
 */
class StatusTrackingFlags extends AbstractStructBase
{
    /**
     * The delivered
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $delivered;
    /**
     * The hostDeleted
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $hostDeleted;
    /**
     * The deleted
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $deleted;
    /**
     * The opened
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $opened;
    /**
     * The full
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $full;
    /**
     * Constructor method for StatusTrackingFlags
     * @uses StatusTrackingFlags::setDelivered()
     * @uses StatusTrackingFlags::setHostDeleted()
     * @uses StatusTrackingFlags::setDeleted()
     * @uses StatusTrackingFlags::setOpened()
     * @uses StatusTrackingFlags::setFull()
     * @param bool $delivered
     * @param bool $hostDeleted
     * @param bool $deleted
     * @param bool $opened
     * @param bool $full
     */
    public function __construct($delivered = null, $hostDeleted = null, $deleted = null, $opened = null, $full = null)
    {
        $this
            ->setDelivered($delivered)
            ->setHostDeleted($hostDeleted)
            ->setDeleted($deleted)
            ->setOpened($opened)
            ->setFull($full);
    }
    /**
     * Get delivered value
     * @return bool|null
     */
    public function getDelivered()
    {
        return $this->delivered;
    }
    /**
     * Set delivered value
     * @param bool $delivered
     * @return \StructType\StatusTrackingFlags
     */
    public function setDelivered($delivered = null)
    {
        // validation for constraint: boolean
        if (!is_null($delivered) && !is_bool($delivered)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($delivered)), __LINE__);
        }
        $this->delivered = $delivered;
        return $this;
    }
    /**
     * Get hostDeleted value
     * @return bool|null
     */
    public function getHostDeleted()
    {
        return $this->hostDeleted;
    }
    /**
     * Set hostDeleted value
     * @param bool $hostDeleted
     * @return \StructType\StatusTrackingFlags
     */
    public function setHostDeleted($hostDeleted = null)
    {
        // validation for constraint: boolean
        if (!is_null($hostDeleted) && !is_bool($hostDeleted)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($hostDeleted)), __LINE__);
        }
        $this->hostDeleted = $hostDeleted;
        return $this;
    }
    /**
     * Get deleted value
     * @return bool|null
     */
    public function getDeleted()
    {
        return $this->deleted;
    }
    /**
     * Set deleted value
     * @param bool $deleted
     * @return \StructType\StatusTrackingFlags
     */
    public function setDeleted($deleted = null)
    {
        // validation for constraint: boolean
        if (!is_null($deleted) && !is_bool($deleted)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($deleted)), __LINE__);
        }
        $this->deleted = $deleted;
        return $this;
    }
    /**
     * Get opened value
     * @return bool|null
     */
    public function getOpened()
    {
        return $this->opened;
    }
    /**
     * Set opened value
     * @param bool $opened
     * @return \StructType\StatusTrackingFlags
     */
    public function setOpened($opened = null)
    {
        // validation for constraint: boolean
        if (!is_null($opened) && !is_bool($opened)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($opened)), __LINE__);
        }
        $this->opened = $opened;
        return $this;
    }
    /**
     * Get full value
     * @return bool|null
     */
    public function getFull()
    {
        return $this->full;
    }
    /**
     * Set full value
     * @param bool $full
     * @return \StructType\StatusTrackingFlags
     */
    public function setFull($full = null)
    {
        // validation for constraint: boolean
        if (!is_null($full) && !is_bool($full)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($full)), __LINE__);
        }
        $this->full = $full;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\StatusTrackingFlags
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
